package cc.sovellus.vrcaa.ui.theme

import android.os.Build
import androidx.compose.foundation.isSystemInDarkTheme
import androidx.compose.material3.MaterialTheme
import androidx.compose.material3.Typography
import androidx.compose.material3.darkColorScheme
import androidx.compose.material3.dynamicDarkColorScheme
import androidx.compose.material3.dynamicLightColorScheme
import androidx.compose.material3.lightColorScheme
import androidx.compose.runtime.Composable
import androidx.compose.ui.platform.LocalContext

@Composable
fun Theme(content: @Composable () -> Unit) {
    val context = LocalContext.current
    MaterialTheme(
        colorScheme = when {
            Build.VERSION.SDK_INT >= Build.VERSION_CODES.S -> {
                if (isSystemInDarkTheme())
                    dynamicDarkColorScheme(context)
                else
                    dynamicLightColorScheme(context)
            }
            else -> {
                if (isSystemInDarkTheme())
                    darkColorScheme()
                else
                    lightColorScheme()
            }
        },
        typography = Typography(),
        content = content,
    )
}